"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _common = require("../common");

var mergeFunctionTrigger = function mergeFunctionTrigger(fn, field) {
  var internalTriggers = [];
  var internalWhen = fn(field);

  if (Array.isArray(internalWhen)) {
    internalTriggers = (0, _toConsumableArray2["default"])(internalWhen);
  } else {
    internalTriggers.push(internalWhen);
  }

  return internalTriggers;
};

var getConditionTriggers = (0, _common.memoize)(function (condition, field) {
  var triggers = [];

  if (Array.isArray(condition)) {
    return condition.reduce(function (acc, item) {
      return [].concat((0, _toConsumableArray2["default"])(acc), (0, _toConsumableArray2["default"])(getConditionTriggers(item, field)));
    }, []);
  }

  var when = condition.when,
      rest = (0, _objectWithoutProperties2["default"])(condition, ["when"]);
  var nestedKeys = ['and', 'or', 'sequence'];

  if (typeof when === 'string') {
    triggers = [].concat((0, _toConsumableArray2["default"])(triggers), [when]);
  }

  if (typeof when === 'function') {
    triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(mergeFunctionTrigger(when, field)));
  }

  if (Array.isArray(when)) {
    when.forEach(function (item) {
      if (typeof item === 'string') {
        triggers = [].concat((0, _toConsumableArray2["default"])(triggers), [item]);
      }

      if (typeof item === 'function') {
        triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(mergeFunctionTrigger(item, field)));
      }
    });
  }

  nestedKeys.forEach(function (key) {
    if (typeof rest[key] !== 'undefined') {
      rest[key].forEach(function (item) {
        triggers = [].concat((0, _toConsumableArray2["default"])(triggers), (0, _toConsumableArray2["default"])(getConditionTriggers(item, field)));
      });
    }
  });
  return Array.from(new Set(triggers));
});
var _default = getConditionTriggers;
exports["default"] = _default;